import pandas as pd
import numpy as np

import os
import sys
from sklearn import feature_extraction
from sklearn.feature_extraction.text import TfidfTransformer
from sklearn.feature_extraction.text import CountVectorizer
import os

if __name__ == "__main__":
	datas = open('C:/Users/lenovo/Desktop/kmeans/dataset.txt','r',encoding='utf-8',errors='ignore').readlines()
	ids = []
	corpus = []
	for tmp in datas:
		ids.append(tmp.split('\t')[0])
		corpus.append(tmp.split('\t')[1])

	vectorizer = CountVectorizer()
	transformer = TfidfTransformer()
	tfidf = transformer.fit_transform(vectorizer.fit_transform(corpus))


	from sklearn.cluster import KMeans
	km = KMeans(n_clusters=13)
	km.fit(tfidf)
	label = km.labels_

	res = pd.DataFrame(list(zip(ids,label)))
	res.head(2)

	

	km1 = KMeans(n_clusters=12)
	km1.fit(tfidf)
	label1 = km1.labels_
	res1 = pd.DataFrame(list(zip(ids, label1)))
	
                

                km1 = KMeans(n_clusters=14)
	km1.fit(tfidf)
	label1 = km1.labels_
	res1 = pd.DataFrame(list(zip(ids, label1)))
	


                km1 = KMeans(n_clusters=10)
	km1.fit(tfidf)
	label1 = km1.labels_
	res1 = pd.DataFrame(list(zip(ids, label1)))

	
	from sklearn.cluster import KMeans
	km = KMeans(n_clusters=13)
	km.fit(tfidf)
	label = km.labels_

	res = pd.DataFrame(list(zip(ids,label)))
	res.head(2)


        c0 = res.loc[res[1]==0,]
        c0
        c1 = res.loc[res[1]==1,]
        c1
        c2 = res.loc[res[1]==2,]
        c2
        c3 = res.loc[res[1]==3,]
        c3
        c4 = res.loc[res[1]==4,]
        c4
        c10 = res.loc[res[1]==10,]
        c10
        len(c10)
        c11 = res.loc[res[1]==11,]
        c11
        c12 = res.loc[res[1]==12,]
        c12



        
	

	import json
	f12 = open("C:/Users/lenovo/Desktop/kmeans/res.json", encoding='utf-8')
	rel_data12 = json.load(f12)
	arr1 = []
	for d1 in rel_data12.keys():
		for d2 in rel_data12[d1].keys():
			arr1.append((d1,d2))

	ct = 0
	for m in range(len(arr1)-1):
		for n in range(m+1,len(arr1)):
			if (arr1[m][0]==arr1[n][1] and arr1[m][1]==arr1[n][0]):
				ct+=1
	print('k=12',ct)

	f = open("res13.json", encoding='utf-8')
	rel_data12 = json.load(f)
	arr1 = []
	for d1 in rel_data12.keys():
		for d2 in rel_data12[d1].keys():
			arr1.append((d1,d2))

	ct = 0
	for m in range(len(arr1)-1):
		for n in range(m+1,len(arr1)):
			if (arr1[m][0]==arr1[n][1] and arr1[m][1]==arr1[n][0]):
				ct+=1
	print('k=13', ct)



